#ifndef G3DLINE_H
#   define G3DLINE_H

void
G3D_line_N(/* OUT shape function value corresponding to */
           double n[2],
           double xi
           /* IN coordinate in the double-unit segment */
           );


/* Returns the derivative of the interpolation matrix {N} by xi, */
/* evaluated at a Gauss point xi. */
void
G3D_line_N_xi(double n_xi[2], double xi);


void
G3D_line_J(double *J,      /* OUT */
           double xi,     /* IN */
           double x0, 
           double x1
           );

int
G3D_closest_points_on_segments (G3D_loc_t *p0, G3D_loc_t *p1,
                                G3D_loc_t *q0, G3D_loc_t *q1,
                                G3D_loc_t *cp, G3D_loc_t *cq);

int
G3D_line_inv_map (double *xi, double x, double x1, double x2);

#endif /* G3DLINE_H */
