
#include "g3d.h"
#include "g3dutil.h"


void
G3D_line3_N(/* OUT shape function value corresponding to */
           double n[3],
           double xi
           /* IN coordinate in the double-unit segment */
           )
            
{
  n[0] = 0.5 * (-xi) * (1 - xi);
  n[1] =       (1 - xi*xi);
  n[2] = 0.5 * (+xi) * (1 + xi);
}



/* Returns the derivative of the interpolation matrix {N} by xi, */
/* evaluated at a Gauss point xi. */
void
G3D_line3_N_xi(double n_xi[3], double xi)
{
  n_xi[0] = -0.5+xi;
  n_xi[1] =  -2*xi;
  n_xi[2] = 0.5+xi;
}

/* Computes the jacobian matrix  J(x,y) */
void
G3D_line3_J(double *J,      /* OUT */
           double xi,     /* IN */
           double x0, 
           double x1,
           double x2
           ) 
{
  double n_xi[3];
  G3D_line3_N_xi (n_xi, xi);
  J[0] = n_xi[0] * x0 + n_xi[1] * x1 + n_xi[2] * x2;
}


