#ifndef G3DPOLY_H
#   define G3DPOLY_H


G3D_poly_t *
G3D_new_poly(int num_vert,
             G3D_vertex_t *vertex,
             G3D_vertex_coords_func get_loc
             );

int
G3D_get_vert_loc(G3D_poly_t *p, int vert, G3D_loc_t *loc);

G3D_bool_t
G3D_poly_is_planar(G3D_poly_t *p, double warp_frac);

void
G3D_poly_bbox(G3D_poly_t *p, G3D_box_t *bb);

void
G3D_poly_recompute_bbox(G3D_poly_t *p);

G3D_bool_t
G3D_segment_intersects_poly(G3D_segment_t *s, G3D_poly_t *p, double eps);

G3D_poly_t *
G3D_modify_poly(G3D_poly_t *p,
                int num_vert,
                G3D_vertex_t *vertex,
                G3D_vertex_coords_func get_loc
                );

#endif /* G3DPOLY_H */
