#ifndef G3DQUAD8_H
#   define G3DQUAD8_H


#ifdef G3DQUAD8_TOPO_PRIVATE_HEADER

#else

#endif

void
G3D_q8_N (/* OUT shape function value corresponding to */
          double n[8],
          double xi, double eta
          /* IN coordinates in the double-unit square */
          );

/* Returns the derivative of the interpolation matrix {N} by xi, */
/* evaluated at a Gauss point eta, xi. */
void
G3D_q8_N_xi (double n_xi[8], double xi, double eta);

/* Returns the derivative of the submatrix {N2} of the displacement */
/* interpolation matrix {N} by eta, evaluated at a Gauss point eta, xi. */
void
G3D_q8_N_eta (double n_eta[8], double xi, double eta);

/* Computes the jacobian matrix  J(x,y) */
void
G3D_q8_J (double J[2][2],            /* OUT */
          double xi, double eta,    /* IN */
          double x1, double y1,      /* IN */
          double x2, double y2,
          double x3, double y3,
          double x4, double y4,
          double x5, double y5,
          double x6, double y6,
          double x7, double y7,
          double x8, double y8
         );

double
G3D_q8_detJ (double J[2][2]);

void
G3D_q8_invJ (double J[2][2], double inv_J[2][2]);

#endif /* G3DQUAD8_H */
